import sqlite3
import openpyxl

class sqlconnections:
   def __init__(self):
      self.conn = sqlite3.connect("pqr.db")
      self.cur = self.conn.cursor()
      self.wkb = openpyxl.load_workbook("Excel_To_Database.xlsx")
      self.sh =  self.wkb['Input']
      self.Newsh = self.wkb.create_sheet(index = 2)
      print("Connection established with database")
       
   def CreateTable(self):
       self.cur.execute('CREATE TABLE  IF NOT EXISTS April (Item text, Quantity integer, Price integer)')
       print("Table created")
       for r in  range(4, 12):    
               item = self.sh.cell(row = r, column =2).value
               quantity = self.sh.cell(row = r, column =3).value
               price = self.sh.cell(row = r, column = 4).value   
               self.cur.execute("INSERT INTO   April (Item, Quantity, Price) VALUES (?, ?, ?)",(item, quantity, price))
               self.conn.commit()
       print('Data inserted')

   def createnewworksheet(self, sheetname):        
         self.Newsh.title = sheetname
         self.Newsh['C1'] = 'Input'
         self.Newsh['L1'] = 'Output'   
         for r in  range(3, 12):
             for c in range(2, 5):
               self.Newsh.cell(row = r, column = c).value = self.sh.cell(row = r, column =c).value          
         print('new worksheet created and data copied')         
 
   def Retrieve_Records(self,sqlquery,rownumber):
               self.cur.execute(sqlquery)
               output = self.cur.fetchall()                               
               for eachtuple in output:
                  print(eachtuple)
                  columnnumber = 11
                  for eachcell in eachtuple:
                           self.Newsh.cell(row = rownumber, column =  columnnumber).value = eachcell                           
                           columnnumber = columnnumber + 1                        
                  rownumber = rownumber + 1
               print('records retrieved')
                
   def SaveWorkbook(self):
      self.wkb.save("Excel_To_Database.xlsx")
      print('Workbook Saved')
      
   def CloseConnections(self):
      self.cur.close()
      self.conn.close()
      print('Connection Closed')

      

sql = sqlconnections()       
#sql.CreateTable()            
sql.createnewworksheet("Particular Cols")
sql.Retrieve_Records("select Item, Price from April",8)
sql.SaveWorkbook()
sql.CloseConnections()
 
